import cx from 'classnames';
import PropTypes from 'prop-types';
import { SIZES, STATUS } from '../settings.js';
import { INDICATOR_CLASS_NAME } from './settings.js';
import { jsxs as _jsxs } from "react/jsx-runtime";
var Indicator = function Indicator(_ref) {
  var percentage = _ref.percentage,
    status = _ref.status,
    errorIcon = _ref.errorIcon,
    size = _ref.size,
    children = _ref.children;
  if (status === STATUS.LOADING) return null;
  return /*#__PURE__*/_jsxs("span", {
    className: cx(INDICATOR_CLASS_NAME, INDICATOR_CLASS_NAME + "--" + status, INDICATOR_CLASS_NAME + "--" + size),
    children: [status === STATUS.PROGRESS && (children || percentage + "%"), status === STATUS.ERROR && errorIcon]
  });
};
export default Indicator;