import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["type", "size"];
import PropTypes from 'prop-types';
import ProgressBarCircle from './ProgressBarCircle/index.js';
import ProgressBarLine from './ProgressBarLine/index.js';
import { LINE_CAPS, SIZES, STATUS, STROKE_SIZES, TYPES } from './settings.js';
import { jsx as _jsx } from "react/jsx-runtime";
var AtomProgressBar = function AtomProgressBar(_ref) {
  var type = _ref.type,
    size = _ref.size,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  switch (type) {
    case TYPES.CIRCLE:
      return /*#__PURE__*/_jsx(ProgressBarCircle, _extends({
        size: size
      }, props));
    case TYPES.LINE:
    case TYPES.LINE_DOUBLE_BAR:
    default:
      return /*#__PURE__*/_jsx(ProgressBarLine, _extends({
        size: size
      }, props));
  }
};
AtomProgressBar.displayName = 'AtomProgressBar';
AtomProgressBar.defaultProps = {
  type: TYPES.LINE,
  status: STATUS.PROGRESS
};
export default AtomProgressBar;
export { LINE_CAPS as atomProgressBarLineCaps, STROKE_SIZES as atomProgressBarStrokeSizes, SIZES as atomProgressBarSizes, STATUS as atomProgressBarStatus, TYPES as atomProgressBarTypes };